<template>
    <q-input bg-color="secondary" :rules="rules" color="white" label-color="white"
             filled :value="DateFormatted"
             @input="Input" :mask="Mask" label="Date and Time">
        <template v-slot:append>
            <q-icon name="today" class="cursor-pointer">
                <q-popup-proxy transition-show="scale" transition-hide="scale">
                    <q-date :value="DateFormatted" @input="Input" mask="YYYY-MM-DD HH:mm:ss">
                        <div class="row items-center justify-end">
                            <q-btn v-close-popup label="Close" color="primary" flat/>
                        </div>
                    </q-date>
                </q-popup-proxy>
            </q-icon>
            <q-icon name="schedule" class="cursor-pointer">
                <q-popup-proxy transition-show="scale" transition-hide="scale">
                    <q-time :value="DateFormatted" @input="Input" mask="YYYY-MM-DD HH:mm:ss" with-seconds
                            format24h>
                        <div class="row items-center justify-end">
                            <q-btn v-close-popup label="Close" color="primary" flat/>
                        </div>
                    </q-time>
                </q-popup-proxy>
            </q-icon>
        </template>
    </q-input>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {format, parse} from "date-fns";

@Component
export default class DateTimePicker extends Vue {
    @Prop() prop!: string
    @Prop() value!: Date;
    @Prop() rules!: any;

    get Mask() {
        return "####-##-## ##:##:##"
    }

    Input(e: string) {
        const dt = parse(e, "yyyy-MM-dd HH:mm:ss", new Date());
        this.$emit('input', dt)
    }

    get DateFormatted() {
        const v = format(this.value, "yyyy-MM-dd HH:mm:ss");
        return v;
    }

}
</script>

<style lang='scss' scoped>

</style>
